#include <mega8.h>
#include <delay.h>
#include <stdio.h>
#include <alcd.h>

#define ADC_VREF_TYPE 0x60

// Read the 8 most significant bits
// of the AD conversion result
unsigned char read_adc(unsigned char adc_input)
{
ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
// Delay needed for the stabilization of the ADC input voltage
delay_us(10);
// Start the AD conversion
ADCSRA|=0x40;
// Wait for the AD conversion to complete
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCH;
}


signed char min_temp,max_temp;
char setting(void);//setting menu
char s_max(void);  //max temp setting 
char s_min(void);  //min temp setting

void main(void){
unsigned char lcd_buffer[17],lcd_buffer_2[17];

long temp=0;




    DDRC=(1<<DDC4)|(1<<DDC5);  
        
    DDRB=(0<<DDB1)|(0<<DDB2)|(0<<DDB3);
    PORTB.1=1;PORTB.2=1;PORTB.3=1;       
    
    ADMUX=ADC_VREF_TYPE & 0xff;
ADCSRA=0x86;
                                      
lcd_init(16);
lcd_clear();
lcd_putsf("Melec");
delay_ms(1);
lcd_gotoxy(0,1);
lcd_putsf("Termostat");
delay_ms(2000);
                                  
    min_temp=20;
    max_temp=30;      
         
   while(1){    
   
 
                    
                   temp = read_adc(0); 
                    temp = temp*2 ;
                   sprintf(lcd_buffer, "  T= %d%cC",temp,223);  
                   sprintf(lcd_buffer_2," %d%cC <T< %d%cC",min_temp,223,max_temp,223);
                    
                   lcd_clear();
                   lcd_puts(lcd_buffer);
                   delay_ms(1);                      
                   lcd_gotoxy(0,1);  
                   lcd_puts(lcd_buffer_2);
                   delay_ms(100);
                  
                  if((temp)>max_temp){  // FAN 
                      PORTC.4=1;
                      }
                    else{
                      PORTC.4=0;
                    }
                   
                 if((temp)<min_temp){   // HEATER 
                 PORTC.5=1;
                 }         
                  else{
                   PORTC.5=0;
                  }          
                  
                  if(PINB.3==0){ // setting pin 
                  while(PINB.3==0);
                  setting();
                  }

   }
}

///////////////// setting 

char setting(void){
 lcd_clear();
 lcd_putsf("Select Setting"); 
 delay_ms(1);
 lcd_gotoxy(0,1);
 lcd_putsf("<< Min OR Max >>"); 
 
 while(1){        
 
             
 
   if(PINB.1==0){ // min setting 
   while(PINB.1==0);
   s_min();    
   return 0;
                  }
                  
    if(PINB.2==0){ // max setting 
   while(PINB.2==0);
   s_max();
   return 0;
                  } 
                  
                  if(PINB.3==0){ // setting pin 
             while(PINB.3==0);
             return 0;
                  }
 
 }

}

char s_min(void){
   char buffer[17]; 
  lcd_clear();
  while(1){               
  
sprintf(buffer,"Min_tmp=%d",min_temp);
lcd_gotoxy(0,0);
lcd_putsf("                ");
lcd_gotoxy(0,0);
lcd_puts(buffer);
       if(PINB.3==0){ // setting pin 
             while(PINB.3==0);
             return 0;
                  } 
                  
        if(PINB.1==0){ // min setting 
   while(PINB.1==0);
       min_temp--;
                  }
                  
    if(PINB.2==0){ // max setting 
   while(PINB.2==0);
      min_temp++;
                  }          
                  
  }

}

char s_max(void){
  char buffer[17]; 
  lcd_clear();
 while(1){  
 
 sprintf(buffer,"Max_tmp=%d",max_temp);
lcd_gotoxy(0,0);
lcd_putsf("                ");
lcd_gotoxy(0,0);
lcd_puts(buffer);
       if(PINB.3==0){ // setting pin 
             while(PINB.3==0);
             return 0;
                  } 
                  
        if(PINB.1==0){ // min setting 
   while(PINB.1==0);
       max_temp--;
                  }
                  
    if(PINB.2==0){ // max setting 
   while(PINB.2==0);
      max_temp++;
                  } 
  
  }

}